import { relations } from 'drizzle-orm';
import * as t from 'drizzle-orm/pg-core';
import { timestamps } from '../util';
import { permissionsToRoles, usersToRoles } from './schema';

export const roles = t.pgTable('role', {
	id: t.uuid('id').primaryKey().defaultRandom(),
	name: t.text('name').notNull().unique(),
	description: t.text('description').notNull(),
	...timestamps
});

export const rolesRelations = relations(roles, ({ many }) => ({
	permissionsToRoles: many(permissionsToRoles),
	usersToRoles: many(usersToRoles)
}));

export type Role = typeof roles.$inferSelect;
