import * as t from 'drizzle-orm/pg-core';
import { binaryHash, timestamps } from '../util';
import { users } from './users';

export const sessions = t.pgTable('session', {
	id: t.uuid('id').primaryKey(),
	secret_hash: binaryHash('secret_hash').notNull(),
	user_id: t
		.uuid('user_id')
		.notNull()
		.references(() => users.id),
	expires_at: t
		.timestamp('expires_at', { withTimezone: true, mode: 'date' })
		.notNull(),
	...timestamps
});

export type Session = typeof sessions.$inferSelect;
